Core - Task # 51094

Epic # 55070 (Accepted): Workpackages
Epic # 54260 (Accepted): WP: FAL Missing Issues / Features / API
Story # 54266 (New): As an User | want FAL to be performant

Status: Resolved Priority: Should have

Author: Tobias Klepp Category: File Abstraction Layer (FAL)
Created: 2013-08-15 Assigned To:

Updated: 2015-01-30 Due date:

TYPOS3 Version: 6.0

PHP Version: 5.3

Complexity: medium

Sprint Focus:

Subject: SQL-Optimize the FAL

Description

In the process of entering a lot of data in the TYPOQ3 6.1 backend, | have some realy big FAL performance problems.

| programmed an extension, that shows a list of 10 records per page. Every record has an image that is connected as a reference.

This simple SQL takes over 35 seconds, because the SQL optimizer can't use an index for the two important fields "tablenames" and

"fieldname" in the sys_file_reference table. If | have a lot of images in the system (over 5000), it takes a lot of time and makes the

website unuseable. | created a new index on the sys_file_reference table with the following statement:

CREATE INDEX tablenames_fieldname_uids

ON sys_file_reference (tablenames(50),fieldname(50),uid_foreign,uid_local);

This key improves the SELECT statement very much. The same simple SQL takes less than 1 second.

| think, the key length can be optimized. A better index would be a unique index, but it is possible to reference the same file more than
once in an mn relation file field. | have no idea, if this functionality is needed. For me, it makes no sense to reference the same file in

the same field more than once.

Subtasks:

Task # 54730: sys_file_processedfile.checksum shorten DB field
Task # 54726: sys_file_reference.fieldname optimize columns
Task # 54725: Add Indexes to sys_file_reference

Resolved
Resolved
Resolved

Related issues:

related to Core - Bug # 51529: FAL is incredibly slow since all information a...

Resolved

2013-08-29

History

#1 - 2013-08-16 12:59 - Philipp Gampe
- Status changed from New to Accepted

- Target version deleted (next-patchlevel)
- TYPOS3 Version changed from 6.1 to 6.0
- Complexity set to medium

FAL guys need to have a look at the queries indexes.

#2 - 2013-08-30 10:52 - Bernhard Kraft

2015-08-04
Related: #51529

#3 - 2013-12-07 16:28 - Steffen Ritter
- Subject changed from Improve FAL performance to Add index to sys_file reference_table
- Parent task set to #54266

#4 - 2013-12-07 17:16 - Steffen Ritter
- Estimated time set to 0.50

- Remaining (hours) set to 0.5
#5 - 2014-01-08 10:12 - Steffen Ritter
- Subject changed from Add index to sys_file_reference_table to SQL-Optimize the FAL

- Estimated time set to 0.00

#6 - 2014-01-08 11:30 - Steffen Ritter
- Estimated time deleted (0.00)

#7 - 2015-01-24 15:52 - Mathias Schreiber
- Status changed from Accepted to Resolved
- Remaining (hours) deleted (0.0)

fixed
